/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@ricochet.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001-2004 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.core;

import java.util.List;
import com.silverwrist.venice.except.AccessError;
import com.silverwrist.venice.except.DataException;
import com.silverwrist.venice.security.Role;

public interface AdminOperations
{
  public SecurityInfo getSecurityInfo();

  public List getAllowedRoleList();

  public List getAuditRecords(int offset, int count) throws DataException;

  public int getAuditRecordCount() throws DataException;

  public AdminUserContext getUserContext(int uid) throws DataException;

  public AdminUserContext getUserContext(String username) throws DataException;

  public CommunityContext getCommunityContext(int cid) throws DataException;

  public CommunityContext getCommunityContext(String alias) throws DataException;

  public GlobalProperties getProperties();

  public void setProperties(GlobalProperties props) throws DataException;

  public AdminUserContext createNewAccount(String username, String password, boolean prehashed, String reminder,
					   boolean verify_email, boolean lockout, Role base_role, String description,
					   java.sql.Date dob, boolean auto_join) throws DataException, AccessError;

  public List getIPBanInfo() throws DataException;

  public IPBanInfo getIPBanInfo(int id) throws DataException;

  public void enableIPBan(int id, boolean enab) throws DataException;

  public void removeIPBan(int id) throws DataException;

  public void addIPBan(String address, String mask, java.util.Date expires, String message) throws DataException;

} // end interface AdminOperations
